package context;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.Map;

import environment.Utils;
import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.util.ContextUtils;
import repast.simphony.util.collections.IndexedIterable;

/*
 * 
 * This class loads an agent with the data in the fishery file.
 * * NOTE: IN THE FILE CAN NOT BE COMMAS WHERE ARE SUPOSE TO BE DECIMAL DOTS
 * 
 * */
public class Ares {


	//private Map<Integer,float[]> naturalMortality;
	private String path;
	private Map<Integer,float[]> fAtAgeTotal;
	private Map<Integer, float[]> sumOfF;
	final String csvSplitBy = ";";
	private Map<Integer, float[]> gilNetItalyFtotal;
	private Map<Integer, float[]> proporzioniF;
	private Map<Integer,float[]> rapidItaly;
	private Map<Integer, float[]> gillNetCroatia;
	private Map<Integer, float[]> gillNetItaly;
	private Map<Integer, float[]> rapidItalyFcorrected;
	private Map<Integer, float[]> gillNetCroatiaFcorrected;
	//private Map<Integer, Map<Integer, float[]>> naturalMortality;
	private Map<Integer, float[]> naturalMortality;


	public Ares(String path) {
		this.path = path;
		//this.fAtAgeTotal = new HashMap<Integer, float[]>();
		//this.sumOfF = new HashMap<Integer,float[]>();
		//this.gilNetItalyFtotal = new HashMap<Integer, float[]>();
		//this.proporzioniF =  new HashMap<Integer, float[]>();
		this.rapidItaly = new HashMap<Integer,float[]>();
		this.gillNetCroatia = new HashMap<Integer,float[]>();
		this.gillNetItaly = new HashMap<Integer, float[]>();
		//this.rapidItalyFcorrected = new HashMap<Integer, float[]>();
		//this.gillNetCroatiaFcorrected = new HashMap<Integer, float[]>();
		this.naturalMortality = new HashMap<Integer, float[]>();

		parse(path);
	}

	private void parse(String filePath) {

		BufferedReader br = null;
		String line = null;
		String[] field;
		try {
			br = new BufferedReader(new FileReader(filePath));
			while ((line = br.readLine()) != null) {
				if(line.startsWith("#Gill Net Italy")){
						parseGillNetItaly(br);

				}else if (line.startsWith("#Gill Net Croatia")) {
					parseGillnetCroatia(br);
					
				} else if (line.startsWith("#Rapid Fishery Italy")) {
					parseRapidItaly(br);
				}
//				} else if (line.startsWith("#Proporzioni di F")) {
//					parseProporzioniF(br);
				//}
//				} else if (line.startsWith("#Rapido_Italy (F AT AGE TOTAL * Selettivita)")) {
//					parseRapidItalyFtotal(br);
//
//				} else if(line.startsWith("#Reti da posta Croazia (F AT AGE TOTAL * Selettivita)")){
//					parseGillnetCroatia(br);
//
//				} else if (line.startsWith("#Reti da posta_Italy F corretta per proporzione")) {
//					parseGillNetItaly(br);
//
//				} else if (line.startsWith("#Rapido_Italy F corretta per proporzione")) {
//					parseRapidItalyFcorrected(br);
//
//				} else if (line.startsWith("#Reti da posta Croazia F corretta per proporzione")) {
//					parseGillNetCroatiaFcorrected(br);
//
//				}
					else if (line.startsWith("#Monthly probability of natural mortality")) {
					parseNaturalMortality(br);
				}
			}			

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}


	}

	private void parseNaturalMortality(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##Code")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					
					int timeData = Integer.parseInt(field[0]);
//					int year = Integer.parseInt(things.substring(0,3));
//					int month = Integer.parseInt(things.substring(things.length()-2)); 
//					Map<Integer,float[]> index = new HashMap<Integer, float[]>();
//					index.put(month, values);
					this.naturalMortality.put(timeData, values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	private void parseGillNetCroatiaFcorrected(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##YEAR")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.gillNetCroatiaFcorrected.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void parseRapidItalyFcorrected(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##YEAR")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.rapidItalyFcorrected.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);

			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void parseGillNetItaly(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line = br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##Code")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.gillNetItaly.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	private void parseGillnetCroatia(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##Code")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.gillNetCroatia.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void parseRapidItaly(BufferedReader br) {
		String line = null;
		String field[];
		try {					
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##Code")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.rapidItaly.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void parseProporzioniF(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ( (line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##YEAR")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[3];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.proporzioniF.put(Integer.parseInt(field[0]),values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	private void parseGilNetItalyFtotal(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line= br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##YEAR")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.gilNetItalyFtotal.put(Integer.parseInt(field[0]), values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void parseSumOfF(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line = br.readLine()) != null && !line.startsWith("##")) {
				if(!line.startsWith("##YEAR") 
						&& line.replaceAll("\\s+", "").length() > 0){
					field = line.split(csvSplitBy);
					float[] values = new float[4];
					for (int i = 0; i < values.length ; i++) {
						values[i]= Float.parseFloat(field[i + 1]);
					}
					this.sumOfF.put(Integer.parseInt(field[0]),values);
				}
				br.mark(1024);

			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}			
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}


	}

	private void parseFAtAgeTotal(BufferedReader br) {
		String line = null;
		String field[];
		try {
			br.readLine();
			while ((line = br.readLine()) != null && !line.startsWith("##")) {
				if (!line.startsWith("##Code")
						&& line.replaceAll("\\s+", "").length() > 0) {
					field = line.split(csvSplitBy);
					float[] values = new float[6];
					for (int i = 0; i < values.length; i++) {
						values[i] = Float.parseFloat(field[i+1]);
					}
					this.fAtAgeTotal.put(Integer.parseInt(field[0]),values);
				}
				br.mark(1024);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			br.reset();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public Map<Integer, float[]> getfAtAgeTotal() {
		return fAtAgeTotal;
	}

	public void setfAtAgeTotal(Map<Integer, float[]> fAtAgeTotal) {
		this.fAtAgeTotal = fAtAgeTotal;
	}

	public Map<Integer, float[]> getSumOfF() {
		return sumOfF;
	}

	public void setSumOfF(Map<Integer, float[]> sumOfF) {
		this.sumOfF = sumOfF;
	}

	public Map<Integer, float[]> getGilNetItalyFtotal() {
		return gilNetItalyFtotal;
	}

	public void setGilNetItalyFtotal(Map<Integer, float[]> gilNetItalyFtotal) {
		this.gilNetItalyFtotal = gilNetItalyFtotal;
	}

	public Map<Integer, float[]> getProporzioniF() {
		return proporzioniF;
	}

	public void setProporzioniF(Map<Integer, float[]> proporzioniF) {
		this.proporzioniF = proporzioniF;
	}

	public Map<Integer, float[]> getRapidItalyFtotal() {
		return rapidItaly;
	}

	public void setRapidItalyFtotal(Map<Integer, float[]> rapidItalyFtotal) {
		this.rapidItaly = rapidItalyFtotal;
	}

	public Map<Integer, float[]> getGillNetCroatia() {
		return gillNetCroatia;
	}

	public void setGillNetCroatia(Map<Integer, float[]> gillNetCroatia) {
		this.gillNetCroatia = gillNetCroatia;
	}

	public Map<Integer, float[]> getGillNetItaly() {
		return gillNetItaly;
	}

	public void setGillNetItaly(Map<Integer, float[]> gillNetItaly) {
		this.gillNetItaly = gillNetItaly;
	}

	public Map<Integer, float[]> getRapidItalyFcorrected() {
		return rapidItalyFcorrected;
	}

	public void setRapidItalyFcorrected(Map<Integer, float[]> rapidItalyFcorrected) {
		this.rapidItalyFcorrected = rapidItalyFcorrected;
	}

	public Map<Integer, float[]> getGillNetCroatiaFcorrected() {
		return gillNetCroatiaFcorrected;
	}

	public void setGillNetCroatiaFcorrected(
			Map<Integer, float[]> gillNetCroatiaFcorrected) {
		this.gillNetCroatiaFcorrected = gillNetCroatiaFcorrected;
	}

//	public Map<Integer, Map<Integer, float[]>> getNaturalMortality() {
//		return naturalMortality;
//	}
	
	public Map<Integer, float[]> getNaturalMortality() {
		return naturalMortality;
	}

//	public void setNaturalMortality(
//			Map<Integer, Map<Integer, float[]>> naturalMortality) {
//		this.naturalMortality = naturalMortality;
//	}
	
	public void setNaturalMortality(
			Map<Integer, float[]> naturalMortality) {
		this.naturalMortality = naturalMortality;
	}

	public Map<Integer, float[]> getRapidItaly() {
		return rapidItaly;
	}

	public void setRapidItaly(Map<Integer, float[]> rapidItaly) {
		this.rapidItaly = rapidItaly;
	}

}
