package context;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;

public class Emigrator {

	String path;
	private Map<String, double[]> rules;
	final String csvSplitBy = ";";

	public Emigrator(String path) {
		this.path = path;
		this.rules = new HashMap<String, double[]>();
		parser(path);
	}

	public void parser(String filePath){
		String line = null;
		BufferedReader br = null;
		String[] field;
		try {
			br = new BufferedReader(new FileReader(filePath));
			//br.readLine();
			while ((line= br.readLine()) != null ) {
				if (!line.startsWith("##")) {
					field = line.split(csvSplitBy);
					double[] values = new double[6];
					String code = null;
					for (int i = 0; i < values.length; i++) {
						values[i] = Double.parseDouble(field[i + 1]);
					}
					code = field[0];
					this.rules.put(code, values);
				}
			}
		}

		catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}


	public Map<String, double[]> getRules() {
		return rules;
	}

	public void setRules(Map<String, double[]> rules) {
		this.rules = rules;
	}
}
