package environment;

import java.util.Iterator;

import org.apache.commons.collections15.functors.InstanceofPredicate;
import org.apache.commons.collections15.iterators.FilterIterator;

import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.gis.GeographyWithin;
import repast.simphony.space.gis.Geography;
import repast.simphony.util.ContextUtils;

public class GillnetFishery {
	private double id;
	private double gridCode;
	private double distance = 0;

	public double getId() {
		return id;
	}

	public void setId(double id) {
		this.id = id;
	}

	public double getGridCode() {
		return gridCode;
	}

	public void setGridCode(double gridCode) {
		this.gridCode = gridCode;
	}

	public GillnetFishery(){

	}

	@ScheduledMethod(start = 0 , priority = ScheduleParameters.FIRST_PRIORITY)
	public void setGillFisheryPresence(){
		Context context = ContextUtils.getContext(this);
		Geography<GillnetFishery> geography = (Geography) context.getProjection("Geography");
		Geometry gillGeomtry = geography.getGeometry(this);
		Envelope envelope = gillGeomtry.getEnvelopeInternal();
		//negative query 
		if(envelope != null){
			for(Hexagon hexagon : geography.getObjectsWithin(envelope, Hexagon.class)){
				hexagon.setGillPresence(true);
			}
		}else{
			//positive query 
			GeographyWithin<Hexagon> within = new GeographyWithin<>(geography,distance,this);
			if (within.query() != null) {
				FilterIterator<Hexagon> filter = new FilterIterator<Hexagon>(within.query().iterator(),
						new InstanceofPredicate(Hexagon.class));
				for (Iterator iter = filter ; filter.hasNext(); ) {
					Hexagon hexagon = (Hexagon) iter.next();
					hexagon.setGillPresence(true);
				}
			}

		}





	}
}
