package environment;

import gov.nasa.worldwind.render.SurfacePolygon;
import gov.nasa.worldwind.render.SurfaceShape;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.visualization.gis3D.style.SurfaceShapeStyle;


public class HexagonStyle implements SurfaceShapeStyle<Hexagon>{

	/*
	 * class 0 color blue 
	 * class 1 color red 
	 * class 2 color green 
	 * class 3 color violet  -- magenta
	 * class 4 color yellow 
	 * class 5 color cyan  
	 * 
	 * sanctuary will be white 
	 * */
	//change it for cohort type... 

	@Override
	public SurfaceShape getSurfaceShape(Hexagon object, SurfaceShape shape) {
		return new SurfacePolygon();
	}

	@Override
	public Color getFillColor(Hexagon obj) {
		double popZero = obj.getClass0Population();
		double popOne = obj.getClass1Population();
		double popTwo = obj.getClass2Population();
		double popThree = obj.getClass3Population();
		double popForth = obj.getClass4Population();
		double popFith = obj.getClass5Population();
		//default is going to be white
		Color color = Color.WHITE;

		List<Double> values = new ArrayList<>();
		values.add(popZero);
		values.add(popOne);
		values.add(popTwo);
		values.add(popThree);
		values.add(popForth);
		values.add(popFith);
		Collections.sort(values);

		double max = values.get(5);
		if (obj.getNumberOfIndividuals() <= 1){
			color = Color.WHITE;

		}else {
			if (max == popZero && popZero > 1 ){
				color = Color.BLUE;
			}else if(max == popOne && popOne > 1){
				color = Color.RED;
			}else if(max == popTwo && popTwo > 1){
				color = Color.GREEN;
			}else if(max == popThree && popThree > 1){
				color = Color.MAGENTA;
			}else if(max == popForth && popForth > 1){
				color = Color.YELLOW;
			}else if (max == popFith && popFith > 1){
				color = Color.CYAN;
			}
			else {
				color = Color.black; //just to see the result
				//Black situation is when the pop is fairly above one i.e 1.003565
				//System.out.println("num of ind: "+ obj.getNumberOfIndividuals() + " id: " +obj.getID());
			}

		}

		//put and check if it's sanctuary 

		return color;
	}

	@Override
	public double getFillOpacity(Hexagon obj) {
		return 0.5;
	}

	@Override
	public Color getLineColor(Hexagon obj) {
		return Color.GREEN;
	}

	@Override
	public double getLineOpacity(Hexagon obj) {
		return 0.3;
	}

	@Override
	public double getLineWidth(Hexagon obj) {
		return 3;
	}
}