package environment;

import gov.nasa.worldwind.render.SurfacePolygon;
import gov.nasa.worldwind.render.SurfaceShape;

import java.awt.Color;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.visualization.gis3D.style.SurfaceShapeStyle;


public class HexagonStylePresence implements SurfaceShapeStyle<Hexagon>{

	/*
	 * class 0 color blue 
	 * class 1 color red 
	 * class 2 color green 
	 * class 3 color violet  -- magenta
	 * class 4 color yellow 
	 * class 5 color cyan  
	 * 
	 * sanctuary will be white 
	 * */


	@Override
	public SurfaceShape getSurfaceShape(Hexagon object, SurfaceShape shape) {
		return new SurfacePolygon();
	}

	@Override
	public Color getFillColor(Hexagon obj) {
		Color color = Color.WHITE;
		if (obj.getPopulationPresence(0)){
			color = Color.RED;
		}
		return color;
	}

	@Override
	public double getFillOpacity(Hexagon obj) {
		return 0.5;
	}

	@Override
	public Color getLineColor(Hexagon obj) {
		return Color.GREEN;
	}

	@Override
	public double getLineOpacity(Hexagon obj) {
		return 0.3;
	}

	@Override
	public double getLineWidth(Hexagon obj) {
		return 3;
	}
}