package environment;

import java.util.Iterator;

import org.apache.commons.collections15.functors.InstanceofPredicate;
import org.apache.commons.collections15.iterators.FilterIterator;

import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.gis.GeographyWithin;
import repast.simphony.space.gis.Geography;
import repast.simphony.util.ContextUtils;

public class RapidFishery {
	//variables
	private double id = 0;
	double distance = 0;//zero because is in the borderline 
	private double total = 0;

	//contructor
	public RapidFishery(){

	}

	public double getId() {
		return id;
	}

	public void setId(double id) {
		this.id = id;
	}

	public double getTotal() {
		return total;
	}

	public void setTotal(double total) {
		this.total = total;
	}

	@ScheduledMethod(start = 0 , priority = ScheduleParameters.FIRST_PRIORITY)
	public void setRapidPresence(){
		Context context  = ContextUtils.getContext(this);
		Geography<RapidFishery> geography = (Geography) context.getProjection("Geography");
		Geometry rapidGeometry = geography.getGeometry(this);
		
		GeographyWithin<Hexagon> whithin = new GeographyWithin<>(geography, distance, this);
		//positive query 
		if(whithin.query() != null){
			FilterIterator<Hexagon> filter = new FilterIterator<Hexagon>(whithin.query().iterator(), 
					new InstanceofPredicate(Hexagon.class));	
			for(Iterator iterator = filter; iterator.hasNext();){
				Hexagon hexagon = (Hexagon) iterator.next();
				hexagon.setRapidPresence(true);
			}
		}else {//negative query 
			Envelope envelope = rapidGeometry.getEnvelopeInternal();
			if (envelope != null){
				for (Hexagon hexagon : geography.getObjectsWithin(envelope, Hexagon.class)){
					hexagon.setGillPresence(true);

				}
			}
			
		}


	}

}
