package environment;

import java.util.Iterator;

import org.apache.commons.collections.functors.InstanceofPredicate;
import org.apache.commons.collections.iterators.FilterIterator;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.gis.GeographyWithin;
import repast.simphony.space.gis.Geography;
import repast.simphony.util.ContextUtils;

import com.vividsolutions.jts.geom.Coordinate;
import com.vividsolutions.jts.geom.Envelope;
import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.operation.buffer.BufferOp;

public class Region {
	int value = 0;
	int populationType;
	double distance = 0;

	public Region(){

	}

	public int getValue() {
		return value;
	}

	public void setValue(int value) {
		this.value = value;
	}

	public int getPopulationType() {
		return populationType;
	}

	public void setPopulationType(int populationType) {
		this.populationType = populationType;
	}

	@ScheduledMethod(start = 0, interval = 0, priority = ScheduleParameters.FIRST_PRIORITY)
	public void populationPresence(){

		Context context = ContextUtils.getContext(this);
		Geography<Region> geography = (Geography)context.getProjection("Geography");
		GeographyWithin<Region> withinTheRegion = new GeographyWithin<Region>(geography, distance , this);
		if(withinTheRegion.query() != null){
			FilterIterator filter = new FilterIterator(withinTheRegion.query().iterator(), 
					new InstanceofPredicate(Hexagon.class));
			for(Iterator iter = filter; iter.hasNext();){
				Hexagon hex = (Hexagon) iter.next();
				hex.setClassesPresent(this.getPopulationType());
				
			}
			
		}

		
	}
}
