package environment;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.apache.commons.collections.functors.InstanceofPredicate;
import org.apache.commons.collections.iterators.FilterIterator;

import com.vividsolutions.jts.geom.Geometry;

import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.gis.GeographyWithin;
import repast.simphony.space.gis.Geography;
import repast.simphony.util.ContextUtils;
import repast.simphony.util.collections.IndexedIterable;

public class Sanctuary {
	private int ID;
	private double latitude;
	private double longitude;

	public int getID() {
		return ID;
	}

	public void setID(int iD) {
		ID = iD;
	}

	public double getLatitude() {
		return latitude;
	}

	public void setLatitude(double latitude) {
		this.latitude = latitude;
	}

	public double getLongitude() {
		return longitude;
	}

	public void setLongitude(double longitude) {
		this.longitude = longitude;
	}

	public Sanctuary(){

	}


	@ScheduledMethod(start = 0, interval = 0 , priority = ScheduleParameters.LAST_PRIORITY)
	public void becomeASanctuary(){
		Context context = ContextUtils.getContext(this);
		Geography<Sanctuary> geography = (Geography)context.getProjection("Geography");
		IndexedIterable<Hexagon> iterHexagons = context.getObjects(Hexagon.class);
		Geometry hexagonSanctuary = geography.getGeometry(this);

		
		/**
		 * IDEA: Add the logic where it checks if the ID or the coordinates are present 
		 * Remember to generate always the sanctuary shapefile with the same id as the hexagon
		 */
		IndexedIterable<Sanctuary> iterSanc = context.getObjects(Sanctuary.class);
		if (iterSanc != null) {
			for (Sanctuary hexSanctuary : iterSanc) {
				Sanctuary san = (Sanctuary) hexSanctuary;
				int sanID = san.getID();
				double sanLatitude = san.getLatitude();
				double sanLongitude = san.getLongitude();
				for (Hexagon hexa : iterHexagons) {
					Hexagon hexagon = (Hexagon) hexa;
					if ((hexagon.getID() == sanID) ||
							(sanLatitude == hexagon.getCentroidLatitude() && sanLongitude == hexagon.getCentroidLongitude())) {
						System.out.println("sanctuario:" + hexagon.getID());
						hexagon.setSanctuary(true);
					}
					
				}
			}
		}
		
		
		
		
	}

}
