package environment;

import java.io.File;
import java.io.IOException;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Iterator;

import org.apache.commons.collections.functors.InstanceofPredicate;
import org.apache.commons.collections.iterators.FilterIterator;
import org.geotools.data.shapefile.ShapefileDataStore;
import org.geotools.data.simple.SimpleFeatureIterator;
import org.opengis.feature.simple.SimpleFeature;
import org.opengis.referencing.crs.CoordinateReferenceSystem;

import com.vividsolutions.jts.geom.Geometry;
import com.vividsolutions.jts.geom.MultiPolygon;
import com.vividsolutions.jts.geom.Polygon;

import context.Kronos;
import repast.simphony.context.Context;
import repast.simphony.engine.schedule.ScheduleParameters;
import repast.simphony.engine.schedule.ScheduledMethod;
import repast.simphony.query.space.gis.GeographyWithin;
import repast.simphony.space.gis.Geography;
import repast.simphony.util.ContextUtils;
import repast.simphony.util.collections.IndexedIterable;
import repast.simphony.visualization.gis3D.WWUtils;

public class Stations {
	private double lat;
	private double lon;
	private double sole0;
	private double sole1;
	private double sole2;
	private double sole3;
	private double sole4;
	private double sole5Plus;
	private double total;
	private int distance = 1;
	private int name;

	public int getName() {
		return name;
	}

	public double getLat() {
		return lat;
	}

	public void setLat(double lat) {
		this.lat = lat;
	}

	public double getLon() {
		return lon;
	}

	public void setLon(double lon) {
		this.lon = lon;
	}

	public double getSole0() {
		return sole0;
	}

	public void setSole0(double sole0) {
		this.sole0 = sole0;
	}

	public double getSole1() {
		return sole1;
	}

	public void setSole1(double sole1) {
		this.sole1 = sole1;
	}

	public double getSole2() {
		return sole2;
	}

	public void setSole2(double sole2) {
		this.sole2 = sole2;
	}

	public double getSole3() {
		return sole3;
	}

	public void setSole3(double sole3) {
		this.sole3 = sole3;
	}

	public double getSole4() {
		return sole4;
	}

	public void setSole4(double sole4) {
		this.sole4 = sole4;
	}

	public double getSole5Plus() {
		return sole5Plus;
	}

	public void setSole5Plus(double sole5Plus) {
		this.sole5Plus = sole5Plus;
	}

	public double getTotal() {
		return total;
	}

	public void setTotal(double total) {
		this.total = total;
	}

	//constructor
	public Stations() {

	}

	@ScheduledMethod(start = 1, interval = 24 , priority = ScheduleParameters.LAST_PRIORITY)
	public void setStationsFlag(){
		Context context = ContextUtils.getContext(this);
		Geography<Stations> geography = (Geography)context.getProjection("Geography");
		GeographyWithin<Region> withinTheRegion = new GeographyWithin<Region>(geography, distance , this);
		if(withinTheRegion.query() != null){
			FilterIterator filter = new FilterIterator(withinTheRegion.query().iterator(), 
					new InstanceofPredicate(Hexagon.class));
			for(Iterator iter = filter; iter.hasNext();){
				Hexagon hex = (Hexagon) iter.next();
				hex.setNameStation(this.name);
				hex.setStation(true);
			}

		}

	}

	@ScheduledMethod(start = 24, interval = 24, priority = ScheduleParameters.LAST_PRIORITY)
	public void cleaningStation(){
		Context context = ContextUtils.getContext(this);
		//if (context.remove(this) == true) {
			context.remove(this);
		//}

	}

	public void setName(int name) {
		this.name = name;
		
	}

}
