package environment;

import micro.ParametersManager;
import repast.simphony.engine.environment.RunEnvironment;

public class Utils {

	final static double northPointLongitude = 13.843;
	final static double northPointLatitude = 45.844;
	final static double southPointLongitude = 13.843;
	final static double southPointLatitude = 41.841;
	final static double eastPointLongitude = 16.460;
	final static double eastPointLatitude = 44.074;
	final static double westPointLongitude = 12.173;
	final static double westPointLatitude = 44.074; 

	final static double getA = 0.007;
	final static double getB = 3.0638;
	final static double LengthInf = 39.6;
	final static double tZero = -0.46;
	
	final static double[] age0Interval = {0.0, 14.0};
	final static double[] age1Interval = {14.1, 22.5};
	final static double[] age2Interval = {22.6, 28.5};
	final static double[] age3Interval = {28.6, 32.5};
	final static double[] age4Interval = {32.6, 35.0};
	final static double[] age5Interval = {35.1, 50.0};
	
	
	public static double getWeightFromLength(double length){
		return  getA * Math.pow(length, getB);
	}
	
	public static double vonBenrtanlaffyF(int age , double kappa){
		double length = LengthInf * ( 1 - Math.exp(-kappa*(age / 12 - tZero))) ;
		return length; // return length from Age
	}


}
