package micro;

import java.util.Map;

import repast.simphony.engine.environment.RunEnvironment;
import repast.simphony.parameter.Parameters;

public class ParametersManager {

	private static Parameters params = RunEnvironment.getInstance()
			.getParameters();
	public static InputParser parser = new InputParser("misc/"
			+ params.getValueAsString("surveyDataPath"));

	public static int getNumberOfAges() {
		return parser.getNumOfAges();
	}

	public static int getNumberOfYears() {
		return parser.getNumOfYears();
	}

	public static int getFirstYear() {
		return parser.getFirstYear();
	}

	public static boolean isVirginStock() {
		return (Boolean) params.getValue("virginStock");
	}
	public static boolean isNewBornNumVariable() {
		return (Boolean) params.getValue("newBornVariability");
	}

	public static int[] getSpaceSize() {
		return new int[] { (Integer) (params.getValue("worldHeight")),
				(Integer) (params.getValue("worldWidth")) };
	}
	
	public static int getFirstYearData(){
		return (Integer) (params.getValue("firstYearData"));
	}
	public static int getLastYearData(){
		return (Integer) (params.getValue("lastYearData"));
	}

	public static Map<Integer, Map<Integer, float[]>> getFishingMortality() {
		return parser.getFishingMortality();
	}

	public static Map<Integer, float[]> getClassLengthData() {
		return parser.getClassLengthRange();
	}

	
	public static Map<Integer, float[]> getIndexSurveyData() {
		return parser.getIndexSurvey();
	}

	public static Map<Integer, Map<Integer, float[]>> getNaturalMortalityData() {
		return parser.getNaturalMortality();
	}

	public static double getL_inf() {
		return (Double) (params.getValue("l_inf"));
	}

	/*public static Map<Integer, float[]> getKvbfData() {
		return parser.getKvbf();
	}
	*/
	//change
	public static Map<Integer, Map<Integer, float[]>> getKData() {
		return parser.getKData();
	}

	public static double getT_0() {
		return (Double) (params.getValue("t_0"));
	}

	public static double getA_length_weight() {
		return (Double) (params.getValue("a_length_weight"));
	}

	public static double getB_length_weight() {
		return (Double) (params.getValue("b_length_weight"));
	}

	public static double getK_lengthGrow() {
		return (Double) (params.getValue("k_lengthGrow"));
	}
}
